#include "main.h"
#include "string.h"
//--------------------------------------------------------------
unsigned char bt, tmp;
//--------------------------------------------------------------
void interrupt isr(void)
{
  if(TMR0IE&&TMR0IF)      
  {
    TIM0_Callback();
    T0IF=0;
  }
  if(RCIF)
  {
    if(FERR)
    {
      tmp = RCREG;
      return;
    }
    else if (OERR)
    {
      CREN = 0;      
      CREN = 1;
      return;
    }
    bt=RCREG;
    ledprint(bt);
  }
}
//--------------------------------------------
void USART_Transmit(unsigned char tx_byte)
{
  while(!TRMT) ;
  TXREG=tx_byte;
}
//------------------------------------------------
void USART_Transmit_Arr(unsigned char *tx_buff, unsigned int tx_len)
{
  unsigned int cnt=0;
  while(cnt<tx_len)
  {
    USART_Transmit(tx_buff[cnt]);
    cnt++;
  }
}
//------------------------------------------------
void USART_Transmit_Str(char *str_buff)
{
  unsigned int cnt=0;
  unsigned int tx_len = strlen(str_buff);
  while(cnt<tx_len)
  {
    USART_Transmit(str_buff[cnt]);
    cnt++;
  }
}
//------------------------------------------------
void main(void) {
  unsigned int i;
  TRISB = 0x00;
  PORTB = 0xFF;
  OPTION_REG=0b00000011; //Prescaler 16
  INTCON=0xA0;
  TMR0=0;
  TRISC=0xC0;//RC and RC Input (USART (TX) and USART (RX))
  SPBRG=12; //19200
  TX9  = 0;
  TXEN = 1;
  SYNC = 0;
  BRGH = 1;
  TX9D = 0;
  RX9  = 0;
  CREN = 1;
  RX9D = 0;
  RCIE=1;
  GIE=1;
  PEIE=1;
  SPEN = 1;
  while(1)
  {
    for(i=1;i<256;i++)
    {
      USART_Transmit(i);
      __delay_ms(100);
    }
  }
}
